/*
 Makeos2.cmd --- Make Weblint 97 / jweblint 97 for OS/2

To know how to use this file, type `makeos2' on OS/2 command line.

*/
CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
CALL SysLoadFuncs


VERSION 	=	"0.12"

JPDIR		=	"l10n\ja-jp"
PROGRAM		=	"weblint"
PROGRAM2	=	"weblint.cmd"
JPROGRAM	= 	"jweblint"
JPROGRAM2	=	"jweblint.cmd"
PERL		=	"Perl"
DEFAULT_PERL	=	"perl5"
EXTLIB		=	"html-ext.pl"
I18NLIB		=	"htmli18n.pl"
JCODE		=	"jcode.pl"
JCONV		=	JPDIR"\jconv.pl"
PATCH		=	"GNU_Patch"
DEFAULT_PATCH	=	"gpatch"
COPY		=	COPY
MOVE		=	MOVE
RM		=	DEL
TARFILE		=	PROGRAM"-97-"VERSION".tar"
TGZ		=	TARFILE".gz"
ZIPFILE		=	PROGRAM"-97-"VERSION".zip"



ARG para1 .
SELECT
	When para1 = install	Then SIGNAL Install
	When para1 = jinstall	Then SIGNAL Jinstall
	When para1 = OS2	Then SIGNAL Makeos2
	When para1 = OS2J	Then SIGNAL Makeos2j
	When para1 = clean	Then SIGNAL Clean
OTHERWISE
	SAY "Please run makeos2.cmd with one of the following arguments:"
	SAY
	SAY "install    -- install Weblint 97 for OS/2; you MUST make"
	SAY "              Weblint 97 for OS/2 before install"
	SAY "jinstall   -- install jweblint 97 for OS/2; you MUST make"
	SAY "              jweblint 97 (Japanese version of Weblint 97) for OS/2"
	SAY "              before install"
	SAY "OS2        -- make Weblint 97 for OS/2"
	SAY "OS2J       -- make jweblint 97 (Japanese version of Weblint 97) for OS/2"
	SAY "clean      -- remove all patches and files related to install"
	SAY
	EXIT
END

Install:
Say "Which do you want to install `Weblint 97'?"
PARSE PULL BINDIR .
if DirCheck(BINDIR) = 1 then
	do
		Say BINDIR': No Such Dir.'
		EXIT
	end

Say "Which do you want to install Perl library of Weblint 97?"
PARSE PULL LIBDIR .
if DirCheck(LIBDIR) = 1 then
	do
		Say LIBDIR': No Such Dir.'
		EXIT
	end

PARSE PULL LIBDIR .
COPY PROGRAM2 BINDIR
COPY EXTLIB LIBDIR
COPY I18NLIB LIBDIR
EXIT

Jinstall:
Say "Which do you want to install `jweblint 97'?"
PARSE PULL BINDIR .
if DirCheck(BINDIR) = 1 then
	do
		Say BINDIR': No Such Dir.'
		EXIT
	end

Say "Which do you want to install Perl library of jweblint 97?"
PARSE PULL LIBDIR .
if DirCheck(LIBDIR) = 1 then
	do
		Say LIBDIR': No Such Dir.'
		EXIT
	end

COPY JPROGRAM2 BINDIR
COPY EXTLIB LIBDIR
COPY I18NLIB LIBDIR
COPY JCODE LIBDIR
EXIT

Makeos2:
PerlPath = ProgPath(PERL DEFAULT_PERL)
Call ChangeHeader(PROGRAM PROGRAM2 PerlPath)
EXIT

Makeos2j:
PatchPath = ProgPath(PATCH DEFAULT_PATCH)
PerlPath = ProgPath(PERL DEFAULT_PERL)

MOVE JPDIR'\'JCODE '.\'JCODE
PerlPath  JCONV '-s' JPDIR'\euc-jp.patch |' PatchPath
MOVE PROGRAM JPROGRAM
PatchPath '<' JPDIR'\shiftjis.patch'
MOVE EXTLIB EXTLIB'.bak'
MOVE I18NLIB I18NLIB'.bak'
MOVE JPDIR'\README.jp' JPDIR'\README.jp.bak'
MOVE JPDIR'\'JPROGRAM'.1' JPDIR'\'JPROGRAM'.1.bak'
PerlPath JCONV '-s' EXTLIB'.bak >' EXTLIB
PerlPath JCONV '-s' I18NLIB'.bak >' I18NLIB
PerlPath JCONV '-s' JPDIR'\README.jp.bak >' JPDIR'\README.jp'
PerlPath JCONV '-s' JPDIR'\'JPROGRAM'.1.bak >' JPDIR'\'JPROGRAM'.1'

Call ChangeHeader(JPROGRAM JPROGRAM2 PerlPath)
EXIT

Clean:
	RM '*~ *.orig *.bak' JPDIR'\*.patch' JPDIR'\*.bak' TARFILE TGZ ZIPFILE
EXIT

/* -----------------------------------------------------------------------
 DirCheck(InDir)
  --- Check directory is exist or not exist.
------------------------------------------------------------------------ */
DirCheck: procedure
ARG InDir .
InDir = TRANSLATE(InDir)
if RIGHT(InDir,1) = '\'
	then InDir = LEFT(InDir,LENGTH(InDir) -1)
ParentDir = FILESPEC("path", InDir)
if substr(InDir,2,1) = ':'
	then CheckDir = substr(InDir,3)
	else CheckDir = InDir

call SysFileTree ParentDir, stem, "D"

do i = stem.0 to 1 by -1
	parse VAR stem.i . . . . DirStr
	if SUBSTR(DirStr,3,1) = ':'
		then DirStr = SUBSTR(DirStr,4)
	DirStr = TRANSLATE(DirStr)
	if DirStr = CheckDir then return 0
end
return 1

/* -----------------------------------------------------------------------
 ProgPath(ProgName DefaultProg)
  --- Get and Check Program Path
------------------------------------------------------------------------ */
ProgPath: procedure
ARG ProgName DefaultProg .

DO FOREVER
	Say ProgName "program name ? (default = " DefaultProg ")"
	PARSE PULL InProg .
	IF InProg = "" THEN DO
		InProg = DefaultProg
		Cursor = SysCurPos( WORD( SysCurPos( ), 1 ) -1, 0 )
		SAY InProg
	END
	ChkExt = InProg
	PARSE UPPER VAR ChkExt ChkExt
	IF POS( ".EXE", ChkExt ) = 0 THEN InProg = INSERT(InProg, ".exe")
	DROP ChkExt
	ProgPath = SysSearchPath("PATH", InProg )
	if ProgPath = "" THEN DO
		SAY ProgName" program `"InProg"' Not Found."
	END
	ELSE DO
		SAY ProgName "program `"ProgPath"'. Found."
		SAY "Use this program ? Yes or No ( default = Yes )"
		PULL Anser .
		if (Anser = "") | (Anser = "YES" ) THEN DO
			Cursor = SysCurPos( WORD( SysCurPos( ), 1 ) -1, 0 )
			SAY "Yes"
			LEAVE
		END
        END
END
RETURN ProgPath

/* ------------------------------------------------------------------------
 ChangeHeader(InProg OutProg PerlPath)
  --- Change UNIX Style Perl Header to OS/2 Style Perl Header.
--------------------------------------------------------------------------- */
ChangeHeader: procedure
ARG InProg OutProg PerlPath .
PerlPath = TRANSLATE(PerlPath, XRANGE('a','z'), XRANGE('A','Z'))
CALL LINEOUT OutProg,'EXTPROC' PerlPath '-Sx',1
CALL LINEOUT OutProg,'#!' PerlPath

loop = 1
Do REC = 1 by 1 while LINES(InProg)
	ReadRecord = LINEIN(InProg)
	If loop > 3 then
	Do
		Call LINEOUT OutProg, ReadRecord
	End
	loop = loop + 1
End
RETURN

